SystemOrganization addCategory: #REPLMorph!


Object subclass: #NotebookCell
	instanceVariableNames: 'start end endInput notebook promptMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'REPLMorph'!

PluggableTextMorphWithModel subclass: #REPLMorph
	instanceVariableNames: 'evaluator commandsHistory lastAnswer lastError debugContinuation lastValue queue outputQueueProcess semaphore'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'REPLMorph'!

REPLMorph subclass: #Notebook
	instanceVariableNames: 'geometriesCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'REPLMorph'!

PluggableTextMorph subclass: #REPLPluggableTextMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'REPLMorph'!

TextMorphEditor subclass: #REPLTextMorphEditor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'REPLMorph'!

TextMorphForEditView subclass: #REPLTextMorphForEditView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'REPLMorph'!

NotebookCell class
	instanceVariableNames: ''!

REPLMorph class
	instanceVariableNames: ''!

Notebook class
	instanceVariableNames: ''!

REPLPluggableTextMorph class
	instanceVariableNames: ''!

REPLTextMorphEditor class
	instanceVariableNames: ''!

REPLTextMorphForEditView class
	instanceVariableNames: ''!


!Notebook commentStamp: 'spfa 12/15/2008 00:25' prior: 0!
Experimental...!

!REPLMorph commentStamp: '<historical>' prior: 0!
a PluggableTextMorph providing a read-eval-print loop for interaction with an interpreter or compiler, called evaluator

evaluator must provide a #prompt, an #outputStream and an #evalString: method !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 6/29/2008 14:47'!
acceptDroppingMorph: aMorph event: evt inMorph: dstListMorph 
	
	| commands |

	(aMorph hasProperty: #replCommands) ifFalse: [^ self].

	commands _ (aMorph valueOfProperty: #replCommands) 					difference: self commandsHistory.

	((commands size > 1
		and: [self confirm: 'Add these ', commands size asString, ' commands to history ?'])
	or: [(commands size = 1
		and: [self confirm: 'Add this command to history ?'])])
		ifFalse: [^ self addMorph: aMorph].

	commands do: [:command | self registerCommand: command].
	^ true

! !

!Notebook methodsFor: 'contents' stamp: 'spfa 12/23/2008 15:07'!
acceptTextInModel

	self text indexOf: (Character value: 1) startingAt: selectionInterval last 
		ifAbsent: [^ super acceptTextInModel].

	"update targeted cell, if any"
	(NotebookCell at: (self text embeddedMorphsIndexes reversed 
			detect: [:a |
				a key < selectionInterval last  
					and: [a value hasProperty: #notebookPrompt]]
			ifNone: [^ false]) value)
		refresh.

	self getProperty: #refreshDisplay. "else the prompt does not show up"

	^ true! !

!REPLMorph methodsFor: 'contents' stamp: 'spfa 6/27/2008 14:14'!
acceptTextInModel

	| textToAccept command |

	(self hasProperty: #inCommand)
	ifFalse:
	[
		command _ self currentCommandFor: textMorph contents.
		command ifEmpty: [command _ self pointedCommand].
		(command isNil or: [command isEmpty]) ifTrue: [^ self].
		self insertCommand: command.
	].

	textToAccept := textMorph asText.
	^setTextSelector isNil or:
		[setTextSelector numArgs = 2
			ifTrue: [model perform: setTextSelector with: textToAccept with: self]
			ifFalse: [model perform: setTextSelector with: textToAccept]]
! !

!Text methodsFor: '*REPLMorph' stamp: 'spfa 12/23/2008 15:02'!
addAttributes: anArray

	anArray do: [:att | self addAttribute: att]! !

!Text methodsFor: '*REPLMorph' stamp: 'spfa 12/23/2008 15:03'!
addAttributes: anArray from: anIndex to: bIndex

	anArray do: [:att | self addAttribute: att  from: anIndex to: bIndex]! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 1/5/2009 09:29'!
addCell: input comment: comment

	self setMyText: myContents, self prompt, 
		(input asText addAttributes: self class commandAttributes).

	comment ifNil: [^ self].
	self lastCell prependComment: comment asText! !

!Notebook methodsFor: 'menu' stamp: 'spfa 12/23/2008 15:36'!
addREPL

	self changeGeometry: [:sw |
		sw addMorph: self frame: (0@0 corner: 0.5@1).
		sw addMorph: (REPLMorph on: self evaluator) frame: (0.5@0 corner: 1@1)]

	! !

!Notebook methodsFor: 'menu' stamp: 'spfa 12/23/2008 22:53'!
addWREPL

	| wks |

	wks _ PluggableTextMorph 
			on: self evaluator text: nil 
			accept: #evalText:from: readSelection: nil menu: nil.

	self changeGeometry: [:sw |
		sw addMorph: self frame: (0@0 corner: 0.5@1).
		sw addMorph: wks frame: (0.5@0 corner: 1@0.5).
		sw addMorph: (REPLMorph on: self evaluator) 
			frame: (0.5@0.5 corner: 1@1)]

	! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 12/19/2008 21:11'!
anew

	^ self class at: promptMorph! !

!REPLMorph class methodsFor: 'colors' stamp: 'spfa 12/23/2008 15:09'!
answerAttributes

	^ {TextColor color: Color gray darker}! !

!REPLMorph methodsFor: 'display stream protocol' stamp: 'spfa 6/27/2008 12:22'!
appendEntry

	| stream text |

	stream := evaluator outputStream.
	stream isEmpty ifTrue: [^ self].

	text := stream contents.
	stream resetContents.
	
	self queue nextPut: ((text asString copyReplaceAll: String lf with: String cr)
		asText 
			addAttribute: self class displayAttribute;
			addAttribute: self class displayFontAttribute).
! !

!NotebookCell class methodsFor: 'as yet unclassified' stamp: 'spfa 12/23/2008 12:43'!
at: aMorph
	
	^ self new initializeAt: aMorph! !

!Notebook methodsFor: 'menu' stamp: 'spfa 12/28/2008 11:45'!
buildMenu: aMenu

	super buildMenu: aMenu.

	aMenu add: textMorph acceptOnCR yesNoString, 'accept on CR'
		target: (self lambda acceptOnCR: textMorph acceptOnCR not)
		action: #value.

	aMenu addLine;
		add: 'remove all output' target: self action: #removeAllOutput;
		add: 'evaluate all cells' target: self action: #evaluate;
		add: 'copy from cells' target: self action: #rewritedFromCells.

	(self hasProperty: #storage) ifTrue: [
		"no public usage, MuO devel only..."
		| m |
		m _ self valueOfProperty: #storage.
		aMenu addLine.
		aMenu add: '[DEVEL] store in ', m receiver asString, '>>', m selector
			target: (self lambda storeAsSelector: m selector in: m receiver)
			action: #value
	].

	owner isSystemWindow ifTrue: [
		aMenu addLine.
		(owner submorphs count: [:m | m isMorphicModel]) = 1 ifTrue: [
			aMenu add: 'add REPL' target: self action: #addREPL.
			aMenu add: 'add REPL and workspace' target: self action: #addWREPL.
			aMenu add: 'add dual notebook' target: self action: #dual]
		ifFalse: [aMenu add: 'go full frame' target: self action: #fullFrame].
	].

	^ aMenu
! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 6/29/2008 13:50'!
buildMenu: aMenu

	self commandsHistory do: [:command |
		| str |
		str := command asString withBlanksTrimmed.
		aMenu add: (str truncateWithElipsisTo: 70)
				selector: #insertCommand: argument: str].

	lastAnswer ifNotNil: [
		| str |
		str := lastAnswer asString withBlanksTrimmed.
		aMenu addLine.
		aMenu add: (str truncateWithElipsisTo: 70)
				selector: #insertCommand: argument: str;
				add: 'explore last value' target: lastValue selector: #explore].

	evaluator addItemsToREPLMenu: aMenu.

	commandsHistory isEmpty ifTrue:
		[aMenu add: 'no history yet' action: #yourself]
	ifFalse:
		[
			aMenu addLine;
			add: 'display history' action: #displayHistory;
			add: 'grab history' action: #grabHistory
		].

	debugContinuation ifNotNil: [
		aMenu addLine.
		aMenu add: (('DEBUG ', lastError) truncateWithElipsisTo: 70)
			 target: debugContinuation selector: #value].

	^ aMenu! !

!REPLPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'spfa 6/18/2006 20:23'!
buildMenu: aMenu

	model buildMenu: aMenu.
	^ aMenu! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 12/15/2008 15:42'!
buttonMorph
	
	^ SimpleButtonMorph newWithRoundedCorner
		color: Color whiteSmoke;
		borderColor: Color cornflowerBlue! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 12/27/2008 23:02'!
cellsDo: aBlock

	(self getMyText embeddedMorphsList select: [:m |
		m hasProperty: #notebookPrompt])
		do: [:pm | aBlock value: (NotebookCell at: pm)].
! !

!Notebook methodsFor: 'menu' stamp: 'spfa 12/23/2008 22:44'!
changeGeometry: aBlock

	| po am |

	(po _ owner) isSystemWindow ifFalse: [^ self].
	am _ po submorphs first.
	po removeAllMorphs.
	aBlock value: po.
	po addMorphFront: am
	! !

!REPLMorph methodsFor: 'contents' stamp: 'spfa 9/28/2006 23:27'!
characterLimit

	"we should be able to set this interactively"

	^ 30000! !

!Notebook methodsFor: 'contents' stamp: 'spfa 12/23/2008 14:40'!
clear

	self updateText: '' asText; 
			refreshDisplay: self prompt! !

!REPLMorph methodsFor: 'display stream protocol' stamp: 'spfa 5/27/2008 23:29'!
clear

	self updateText: '' "self prompt".
	self refreshDisplay: self prompt.! !

!Notebook class methodsFor: 'as yet unclassified' stamp: 'spfa 12/23/2008 15:20'!
commandAttributes

	^ {TextColor color: Color blue muchDarker . "TextEmphasis bold"}! !

!REPLMorph class methodsFor: 'colors' stamp: 'spfa 12/23/2008 14:59'!
commandAttributes

	^ {TextColor color: Color blue muchDarker}! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 6/7/2006 23:44'!
commandsHistory

	^ commandsHistory ifNil: [commandsHistory _ OrderedCollection new]
! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 12/23/2008 12:12'!
comment

	^ (notebook getMyText embeddedMorphsIndexes reversed detect: [:array |
		array key < start and: [
			(array value hasProperty: #notebookPrompt) ifTrue: [^ nil].
			array value hasProperty: #notebookComment]]
		ifNone: [^ nil]) value! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 12/21/2008 22:50'!
commentColor

	^ Color grey alpha: 0.1

! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 12/27/2008 23:28'!
contents

	^ Array streamContents: [:str |
		self cellsDo: [:cell | 
			| comment |
			(comment _ cell comment)
				ifNil: [str nextPut: cell inputString]
				ifNotNil: [
					str nextPut: {
							comment contents .
							cell inputString
						}]]]
! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 12/19/2008 21:50'!
contents

	| text |

	text _ notebook getMyText.

	end = text size ifTrue:
		[^ text copyFrom: start to: end].

	^ text copyFrom: start to: end -1! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 12/20/2008 00:06'!
crop

	self replaceFrom: start-1 to: end with: ''.
	self comment ifNotNil: [self removeComment].
! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 12/15/2008 13:31'!
currentCommandFor: text

	| lastLinePos lastLine  |

	lastLinePos _ text lastIndexOfSubCollection: (String cr, self promptString)  ifAbsent: [0].
"	lastLinePos _ text lastIndexOf: Character cr ifAbsent: [ 0 ]."
	lastLinePos _ text asString skipAnySubStr: {self promptString} startingAt: lastLinePos + 1.
	lastLine _ text copyFrom: lastLinePos to: text size.
	^ lastLine asString withBlanksTrimmed! !

!REPLTextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 5/29/2008 14:30'!
cursorPageDown: characterStream 

	self isOnPromptLine
		ifTrue: [model insertNextCommand. ^ true].

	^ super cursorPageDown: characterStream ! !

!REPLTextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 5/29/2008 14:30'!
cursorPageUp: characterStream 

	self isOnPromptLine
		ifTrue: [model insertPreviousCommand. ^ true].

	^ super cursorPageUp: characterStream ! !

!REPLMorph class methodsFor: 'colors' stamp: 'spfa 6/8/2006 14:01'!
displayAttribute

	^ TextColor color: Color red muchDarker muchDarker! !

!REPLMorph class methodsFor: 'colors' stamp: 'spfa 10/2/2006 09:53'!
displayFont

	^ (TextStyle named: #Accumon) 
		fontOfSize: TextStyle defaultFont pointSize! !

!REPLMorph class methodsFor: 'colors' stamp: 'spfa 6/27/2008 12:22'!
displayFontAttribute

	^ TextFontReference toFont: self displayFont! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 5/29/2008 15:11'!
displayHistory

	(Workspace new contents: (String streamContents: [:str |
		self commandsHistory do: [:command |
			str nextPutAll: command; cr]])) 
		openLabel: 'commands history'
	! !

!Notebook methodsFor: 'display stream protocol' stamp: 'spfa 12/23/2008 15:11'!
doCommand: aString

	| answer |

	self setProperty: #inCommand toValue: true.
	self registerCommand: aString.

"	debugContinuation := lastAnswer := lastError := lastValue :=  nil."

	answer _  (self evalCommand: aString) asText 
					addAttributes: self class answerAttributes.

	self setProperty: #inCommand toValue: false.

	self appendEntry; outputQueue.
	self updateText: (aString last == $. 
		ifTrue: [myContents, self separator, String cr]
		ifFalse: [myContents, self separator, answer, String cr, String cr]).
	self refreshDisplay: self prompt.

	self selectFrom: self text size + 1 to: self text size + 1.
	self scrollSelectionIntoView; setScrollDeltas; refreshWorld.


! !

!REPLMorph methodsFor: 'display stream protocol' stamp: 'spfa 12/23/2008 15:09'!
doCommand: aString

	| answer |

	self setProperty: #inCommand toValue: true.
	self registerCommand: aString.

	debugContinuation := lastAnswer := lastError := lastValue :=  nil.

	answer :=  [lastAnswer := (self formatAnswer: 
						(lastValue := evaluator evalString: aString notifying: self)) 
								asText addAttributes: self class answerAttributes]
		on: Error
		do: [:ex | 
				debugContinuation := Continuation current.
				debugContinuation isContinuation
					ifTrue: [(lastError := ex description) asText 
								addAttribute: self class errorAttribute]
					ifFalse: [ex signal]].

	self setProperty: #inCommand toValue: false.

	self appendEntry; outputQueue.
	self updateText: myContents, answer, String cr.
	self refreshDisplay: self prompt.

! !

!Notebook methodsFor: 'menu' stamp: 'spfa 12/23/2008 15:40'!
dual

	self changeGeometry: [:sw |
		sw addMorph: self frame: (0@0 corner: 0.5@1).
		sw addMorph: (Notebook new evaluator: self evaluator) clear
				frame: (0.5@0 corner: 1@1).]

	! !

!REPLTextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 12/15/2008 13:34'!
encompassLine: anInterval
	"Return an interval that encompasses the entire line, minus the promt if present at the beginning"

	| string left right |
	string _ paragraph text string.
	left _ (string lastIndexOf: Character cr startingAt: anInterval first - 1 ifAbsent:[0]) + 1.

	left == 
		(string indexOfSubCollection: model promptString startingAt: left ifAbsent: [nil]) 
	ifTrue: [left _ left + model promptString size].

	right _ (string indexOf: Character cr startingAt: anInterval last + 1 ifAbsent: [string size + 1]) - 1.
	^left to: right! !

!REPLMorph methodsFor: 'display stream protocol' stamp: 'spfa 5/29/2008 13:11'!
endEntry

	self appendEntry.
	(outputQueueProcess notNil
		and: [outputQueueProcess isTerminated not]) ifTrue: [^ self].

	outputQueueProcess _ [50 milliSeconds asDelay wait . self outputQueue] fork
! !

!REPLMorph class methodsFor: 'colors' stamp: 'spfa 6/18/2006 22:26'!
errorAttribute

	^ TextColor color: Color red! !

!Notebook methodsFor: 'display stream protocol' stamp: 'spfa 12/17/2008 14:55'!
evalCommand: aString

	^  [lastAnswer := 
						(lastValue := evaluator evalString: aString notifying: self)
					forNotebook: self]
		on: Error
		do: [:ex | 
				debugContinuation := Continuation current.
				debugContinuation isContinuation
					ifTrue: [(lastError := ex description) asText 
								addAttribute: self class errorAttribute]
					ifFalse: [ex signal]]! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 12/2/2008 14:51'!
evalString: aString

	^ evaluator evalString: aString! !

!REPLMorph methodsFor: 'contents' stamp: 'spfa 6/16/2008 13:48'!
evalText: aString

	^ evaluator evalText: aString! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 12/27/2008 22:08'!
evaluate

	self cellsDo: [:cell | cell evaluate]
! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 12/23/2008 15:12'!
evaluate

	| input val |
	
	input _ self input asString withBlanksTrimmed.
	
	val _ (notebook evalCommand: input) asText 
			addAttributes: notebook class answerAttributes.

	input last == $. ifTrue:
		[^ self output: String cr].

	self output: val, String cr, String cr! !

!REPLTextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 6/9/2008 15:16'!
evaluateSelection
	"Treat the current selection as an expression; evaluate it and return the result"

	self lineSelectAndEmptyCheck: [^ ''].
	^ model evalString: self selectionAsStream contents asString! !

!REPLMorph methodsFor: 'initialization' stamp: 'spfa 12/15/2008 23:45'!
evaluator

	^evaluator
! !

!REPLMorph methodsFor: 'initialization' stamp: 'spfa 6/29/2008 14:26'!
evaluator: anObject

	| fresh |

	(self hasProperty: #inCommand) ifTrue: [^ self].

	fresh _ ''.

	evaluator ifNotNil: [
		self appendEntry; outputQueue.
		fresh _ self freshInput. 
		[fresh beginsWith: String cr] whileTrue: [fresh _ fresh allButFirst].
		(fresh beginsWith: self prompt) 
			ifTrue:	[fresh _ fresh allButFirst: self prompt size]].

	evaluator := anObject.
	self appendEntry; outputQueue.
	evaluator outputStream reset.

	self refreshDisplay: self prompt, fresh

! !

!Notebook methodsFor: 'contents' stamp: 'spfa 12/20/2008 00:35'!
extent: aPoint

	super extent: aPoint.

	textMorph ifNil: [^ self]. "notebook is not fully initialized yet"
	self refreshDisplay: self prompt.! !

!Form methodsFor: '*REPLMorph' stamp: 'spfa 12/15/2008 14:30'!
forNotebook: aNotebook

	^ self asMorph forNotebook: aNotebook
! !

!Morph methodsFor: '*REPLMorph' stamp: 'spfa 1/5/2009 09:21'!
forNotebook: aNotebook

	(self == World or: [owner notNil])
		ifTrue: [^ (self printString, ' [owner: ', owner printString, ']') asText].

	^ aNotebook wrapForOutput: self
! !

!Object methodsFor: '*REPLMorph' stamp: 'spfa 12/15/2008 14:31'!
forNotebook: aNotebook

	^ self asString asText! !

!SimpleButtonMorph methodsFor: '*REPLMorph' stamp: 'spfa 1/5/2009 09:23'!
forNotebook: aNotebook

	^ aNotebook plainOutput: self
! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 6/23/2008 00:13'!
formatAnswer: anObject

	^ anObject printString
	

	

	! !

!REPLMorph methodsFor: 'contents' stamp: 'spfa 5/29/2008 15:25'!
freshInput

	| len tlen |

	len _ myContents ifNil: [0] ifNotNil: [myContents size].
	tlen _ textMorph asText size.
	tlen == len ifTrue: [^ ''].

	^ textMorph asText copyFrom: len to: textMorph asText size

! !

!Notebook methodsFor: 'menu' stamp: 'spfa 12/23/2008 15:37'!
fullFrame

	self changeGeometry: [:sw |
		sw addMorph: self frame: (0@0 corner: 1@1)]

	! !

!REPLMorph methodsFor: 'contents' stamp: 'spfa 6/7/2006 22:09'!
getMyText
	^myContents! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 6/29/2008 14:45'!
grabHistory

	| n |

	n _  self commandsHistory size.
	n > 0 ifFalse: [^ self].

	((StringMorph contents: n asString, ' command', (n>1 ifTrue: ['s'] ifFalse: ['']))
		setProperty: #replCommands toValue: self commandsHistory)
	openInHand
! !

!Notebook methodsFor: 'header' stamp: 'spfa 12/15/2008 23:36'!
headerFont

	^ TextStyle default fontOfSize: 30! !

!Notebook methodsFor: 'header' stamp: 'spfa 12/15/2008 23:31'!
headerLabel

	owner ifNil: [^ ''].

	^ owner label
! !

!Notebook methodsFor: 'header' stamp: 'spfa 12/17/2008 14:03'!
headerText

	| label sbutt sabutt bbutt space |

	label _ MPEGSubtitlesDisplayer on: self selector: #headerLabel.
	label font: self headerFont.

	sbutt _ self buttonMorph label: 'save'; 
			target: self lambda owner saveOnUsualFile; 
			actionSelector: #value.

	sabutt _ self buttonMorph label: 'save as...'; 
			target: self lambda owner saveOnFileRememberWhere; 
			actionSelector: #value.

	space _ (Morph new color: Color transparent; height: 10) asAnchoredText.

	bbutt _ self buttonMorph label: 'bindings'; 
			target: self lambda evaluator bindings quoted explore ; 
			actionSelector: #value.

	^ label asAnchoredText, String cr asText, sbutt asAnchoredText, '  ' asText, sabutt asAnchoredText, space, bbutt asAnchoredText, String cr asText, String cr asText! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 12/19/2008 21:39'!
hideOutput

	| hbutt |

	hbutt _ notebook buttonMorph label: 'show';
					target: (self lambda anew output: self output); 
					actionSelector: #value.

	^ self output: hbutt asAnchoredText, String cr, String cr
! !

!REPLMorph class methodsFor: 'as yet unclassified' stamp: 'spfa 6/8/2006 14:11'!
historyLength

	^ 30! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 12/27/2008 23:10'!
inSystemWindow

	^ self inSystemWindowLabelled: 'notebook'
! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 12/27/2008 23:09'!
inSystemWindowLabelled: aString

	| w |

	w _ SystemWindow labelled: aString.
	w paneColor: self class windowColor.
	w addMorph: self frame: (0@0 corner: 1@1).
	^ w! !

!Notebook methodsFor: 'initialization' stamp: 'spfa 12/17/2008 15:42'!
initialize

	super initialize.
	self getProperty: #alwaysAccept.
	self updateText: self headerText.

! !

!REPLMorph methodsFor: 'initialization' stamp: 'spfa 6/25/2008 11:21'!
initialize
	super initialize.
	self extent: 600@400.
	self color: Color white.
	self acceptOnCR: true.
"	self alwaysShowVScrollBar: true."
	getMenuSelector := #buildMenu:.
	self startStepping



	! !

!NotebookCell methodsFor: 'intialization' stamp: 'spfa 12/23/2008 12:44'!
initializeAt: aMorph

	| text emorphs |

	promptMorph _ aMorph.

	notebook _ promptMorph ownerChain detect: [:m | m isMorphicModel].
	text _ notebook getMyText.

	emorphs _ text embeddedMorphsIndexes.

	start _ (emorphs detect: [:a |
		a value == promptMorph] ifNone: [^ nil]) key.

	end _ (emorphs detect: [:a |
		a key > start 
			and: [(a value hasProperty: #notebookPrompt)
					or: [a value hasProperty: #notebookComment]]]
		ifNone: [text size -> #theEnd]) key.

	endInput _ (text indexOf: notebook separator first 
					startingAt: start ifAbsent: []) -1.
! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 12/23/2008 14:59'!
input

	notebook class commandAttributes do: [:att |
		notebook getMyText addAttribute: att from: start + 1 to: endInput].

	^ notebook getMyText copyFrom: start + 1 to: endInput
			 ! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 12/19/2008 21:05'!
input: aText

	^ self replaceFrom: start+1 to: endInput with: aText! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 12/27/2008 23:40'!
inputString

	^ (notebook getMyText asString copyFrom: start + 1 to: endInput - 1)
		withBlanksTrimmed
			 ! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 12/23/2008 15:03'!
insertCommand: aString

	textMorph newContents: (Text streamContents: [:str |

		| txt |

		str nextPutAll: (myContents ifNil: ['']).

		(self hasProperty: #inCommand) ifFalse: [
			myContents isEmptyOrNil ifFalse: [
				myContents last == Character cr ifFalse: [str cr]].
			str nextPutAll: self prompt].

		txt _ (Text fromString: aString) 
					addAttributes: self class commandAttributes.
		(self hasProperty: #inCommand) 
			ifTrue: [txt addAttribute: self class displayFontAttribute].
		str nextPutAll: txt]).

	textMorph editor selectAt: textMorph asText size + 1.
	self hasUnacceptedEdits: true! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 5/29/2008 14:36'!
insertNextCommand

	| command |
	self commandsHistory ifEmpty: [^ self].
	self insertCommand: (command _ commandsHistory first).
	commandsHistory removeFirst.
	commandsHistory addLast: command! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 5/29/2008 14:37'!
insertPreviousCommand

	| command |
	self commandsHistory ifEmpty: [^ self].
	self insertCommand: (command _ commandsHistory last).
	commandsHistory removeLast.
	commandsHistory addFirst: command! !

!REPLTextMorphForEditView methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2008 13:43'!
installEditorToReplace: priorEditor
	"Install an editor for my paragraph.  This constitutes 'hasFocus'.
	If priorEditor is not nil, then initialize the new editor from its state.
	We may want to rework this so it actually uses the prior editor."

	| stateArray |
	priorEditor ifNotNil: [stateArray := priorEditor stateArray].
	editor := REPLTextMorphEditor new morph: self.
	editor changeParagraph: self paragraph.
	priorEditor ifNotNil: [editor stateArrayPut: stateArray].
	self selectionChanged.
	^ editor! !

!REPLTextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 5/29/2008 14:25'!
isOnPromptLine

	^ self isPromptLine: self selectionInterval
! !

!REPLTextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 5/29/2008 14:24'!
isPromptLine: anInterval

	| string left |
	string _ paragraph text string.
	left _ (string lastIndexOf: Character cr startingAt: anInterval first - 1 ifAbsent:[0]) + 1.

	^ left == 
		(string indexOfSubCollection: model prompt startingAt: left ifAbsent: [nil]) 
! !

!REPLTextMorphForEditView methodsFor: 'as yet unclassified' stamp: 'spfa 10/20/2006 14:38'!
keyStroke: evt
	
"	editView lisp standardInput stream nextPut: evt keyCharacter."
	super keyStroke: evt! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 12/27/2008 23:02'!
lastCell

	^ NotebookCell at: (myContents embeddedMorphsList reversed detect: [:m | 
								m hasProperty: #notebookPrompt])! !

!SequenceableCollection methodsFor: '*REPLMorph' stamp: 'spfa 10/3/2006 10:29'!
lastIndexOfSubCollection: sub ifAbsent: exceptionBlock
	"Answer the index of the receiver's last element, such that that element 
	equals the first element of sub, and the next elements equal 
	the rest of the elements of sub. Begin the search at element 
	end of the receiver. If no such match is found, answer the result of 
	evaluating argument, exceptionBlock."
	| first index |
	sub isEmpty ifTrue: [^ exceptionBlock value].
	first _ sub first.
	self size - sub size + 1 to: 1 by: -1 do:
		[:startIndex |
		(self at: startIndex) = first ifTrue:
			[index _ 1.
			[(self at: startIndex+index-1) = (sub at: index)]
				whileTrue:
				[index = sub size ifTrue: [^startIndex].
				index _ index+1]]].
	^ exceptionBlock value! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 12/23/2008 12:51'!
liveInput

	| ibeg iend |

	ibeg _ (notebook text embeddedMorphsIndexes detect: [:a |
		a value == promptMorph] ifNone: [^ nil]) key.

	iend _ (notebook text indexOf: notebook separator first 
		startingAt: ibeg ifAbsent: [^ nil]) -1.

	^ (notebook text copyFrom: ibeg + 1 to: iend -1) asString withBlanksTrimmed! !

!NotebookCell methodsFor: 'menu' stamp: 'spfa 12/20/2008 00:14'!
menu

	| m comment |

	m _ MenuMorph new defaultTarget: notebook.

	m 
	add: 'swap with ...' selector: #swap: argument: promptMorph;
	add: 'hide output' target: self action: #hideOutput.

	(comment _ self comment) ifNil:
		[m add: 'add comment' target: self action: #prependComment]
		ifNotNil: [
			m add: 'select comment' target: comment action: #addHalo;
			add: 'remove comment' target: self action: #removeComment].

	m
	add: 'remove output' target: self action: #removeOutput ;
	addLine;
	add: 'delete' target: self action: #crop.

	^ m ! !

!Notebook class methodsFor: 'instance creation' stamp: 'spfa 1/5/2009 09:46'!
new: aString contents: anArray

	| nb |

	nb _ self newStandAlone. 
	anArray do: [:cell |
		cell isString ifTrue: [nb addCell: cell comment: nil].
		cell isArray ifTrue: [nb addCell: cell second comment: cell first]].

	nb scroller offset: 0@0.

	^ nb inSystemWindowLabelled: aString
	! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 12/27/2008 22:46'!
newComment: contents

	| tm comment w h |

 	tm _  TextMorph new. 
	tm backgroundColor: self commentColor.
	tm autoFit: true; margins: 5; contents: contents.
	tm getProperty: #notebookComment.

	comment _ String cr asText, tm asAnchoredText.

	w _ self width - 20.
	h _ (tm textStyle defaultFont approxWidthOfText: tm contents)
			* tm textStyle defaultFont height / (w + 1).

	tm wrapFlag: true.
	tm extent: w @ h asInteger.

	^ comment

! !

!Notebook class methodsFor: 'instance creation' stamp: 'spfa 12/27/2008 23:07'!
newStandAlone

	| nb pm |

	pm _ PluggableMemory for: (nb _ self new).
	nb evaluator: pm.

	^ nb
	! !

!NotebookCell methodsFor: 'accessing' stamp: 'spfa 12/19/2008 15:15'!
notebook: anObject
	notebook _ anObject! !

!REPLMorph class methodsFor: 'instance creation' stamp: 'spfa 6/16/2008 13:46'!
on: anObject

	^ self new evaluator: anObject! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 12/19/2008 21:36'!
output

	end == notebook getMyText size
		ifTrue: [^ notebook getMyText copyFrom: endInput+1 to: end].

	^ notebook getMyText copyFrom: endInput+1 to: end-1! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 12/23/2008 12:09'!
output: aText

	^ self replaceFrom: endInput + 1 to: end with: aText! !

!REPLMorph methodsFor: 'display stream protocol' stamp: 'spfa 5/27/2008 23:04'!
outputQueue

	| fresh |

	self queue isEmpty ifTrue: [^ self].

	fresh _ self freshInput. 

	self updateText: (Text streamContents: [:stream |
							stream nextPutAll: (myContents ifNil: ['']).
							self queue size timesRepeat: 
								[stream nextPutAll: self queue next]]).

	self refreshDisplay: fresh! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 12/19/2008 21:48'!
overwriteWith: aText

	^ self replaceFrom: start-1 to: end with: aText
! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 1/5/2009 09:22'!
plainOutput: aMorph

	| m |

	m _ Morph new
			extent: 3@3;
			color: Color transparent;
			layoutInset: 3;
			cellInset: 3;
			wrapCentering: #center;
			hResizing: #shrinkWrap;
			vResizing: #shrinkWrap;
			listDirection: #leftToRight;
			layoutPolicy: TableLayout new.

	m addMorph: aMorph.

	^ m asAnchoredText
! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 12/15/2008 13:29'!
pointedCommand

	| beg end text line prompt |

	text _ textMorph contents asString.
	end _ (text indexOf: Character cr startingAt: selectionInterval last ifAbsent: [text size + 1]) - 1.
	
	beg _ text lastIndexOf: Character cr startingAt: end ifAbsent: [0].
	line _ text asString copyFrom: beg + 1 to: end.
	prompt  _ self promptString.

	(line beginsWith: prompt) ifFalse: [^ nil].

	^ (line copyFrom: (line skipAnySubStr: {prompt} startingAt: 1) to: line size)
			withBlanksTrimmed! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 12/27/2008 22:58'!
prependComment

	self prependComment:  ' ... blah ... '! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 12/27/2008 22:57'!
prependComment: aText

	| fullText  |

	fullText _ notebook getMyText.

	notebook updateText: (fullText copyFrom: 1 to: start -2), 
		(notebook newComment: aText),
		(fullText copyFrom: start -1 to: fullText size).

	notebook refreshDisplay: notebook prompt.! !

!REPLTextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 6/9/2008 15:16'!
printIt
	"Treat the current text selection as an expression; evaluate it. Insert the 
	description of the result of evaluation after the selection and then make 
	this description the new text selection."
	| result |
	result _ self evaluateSelection.
	((result isKindOf: FakeClassPool) or: [result == #failedDoit])
			ifTrue: [view flash]
			ifFalse: [self afterSelectionInsertAndSelect: (result printString)]! !

!Notebook methodsFor: 'initialization' stamp: 'spfa 12/17/2008 15:43'!
prompt
	
	| m |

	m _ self buttonMorph
		target: self;
		actionSelector: #promptMenu:;
		label: super prompt asString withBlanksTrimmed.

	m getProperty: #notebookPrompt.
	m arguments: {m}.

	^ m asAnchoredText, ' ' asText
! !

!REPLMorph methodsFor: 'initialization' stamp: 'spfa 12/20/2008 00:50'!
prompt
	
	^ (evaluator ifNil: [^ '> ']) prompt, ' '! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 12/20/2008 00:01'!
promptMenu: aButtonMorph
	
	| cell promptMorph tempText first second |

	cell _ (NotebookCell at: aButtonMorph) ifNil: [^ self].

	"the following implements cell swapping"

	(self hasProperty: #swap) ifFalse: [^ cell menu popUpInWorld].

	promptMorph _ self valueOfProperty: #swap.
	self removeProperty: #swap.
	promptMorph color: self buttonMorph color.

	promptMorph == aButtonMorph ifTrue: [^ self].

	first _ (NotebookCell at: promptMorph).
	(second _ cell) start < first start 
		ifTrue: [second _ first . first _ cell].
	tempText _ second contents.
	second overwriteWith: first contents.
	first overwriteWith: tempText.
	
! !

!NotebookCell methodsFor: 'accessing' stamp: 'spfa 12/19/2008 16:01'!
promptMorph
	^promptMorph! !

!NotebookCell methodsFor: 'accessing' stamp: 'spfa 12/19/2008 15:30'!
promptMorph: anObject
	promptMorph _ anObject! !

!Notebook methodsFor: 'initialization' stamp: 'spfa 12/15/2008 13:29'!
promptString
	
	^ (Character value: 1) asString
! !

!REPLMorph methodsFor: 'initialization' stamp: 'spfa 12/15/2008 13:28'!
promptString

	^ self prompt asString withoutTrailingBlanks! !

!REPLMorph methodsFor: 'initialization' stamp: 'spfa 9/28/2006 22:43'!
queue

	^ queue ifNil: [queue _ SharedQueue new]! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 12/23/2008 12:51'!
refresh

	self input: (self liveInput ifNil: [^ self]).
	self anew evaluate! !

!Notebook methodsFor: 'contents' stamp: 'spfa 12/19/2008 23:40'!
refreshDisplay: aString

	| fullText |

	fullText _ myContents ifNil: [aString] 
		ifNotNil: [myContents, aString].
	textMorph newContents: fullText.

	geometriesCache _ IdentityDictionary new.

	myContents ifNil: [^ self].

	myContents embeddedMorphs do: [:m |
		(m hasProperty: #notebookComment)
			ifTrue: [m extent: (self width - 20) @ m height.].
		geometriesCache add: m -> m extent]! !

!REPLMorph methodsFor: 'contents' stamp: 'spfa 6/27/2008 14:32'!
refreshDisplay: freshText

	| fullText |

	fullText _ myContents ifNil: [freshText] 
		ifNotNil: [myContents, freshText].
	textMorph newContents: fullText.
	self selectFrom: fullText size + 1 to: fullText size + 1.
	self scrollSelectionIntoView; setScrollDeltas; refreshWorld.
	

! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 5/29/2008 13:16'!
registerCommand: aString

	self commandsHistory remove: aString ifAbsent: [].
	commandsHistory addFirst: aString.
	commandsHistory size > self class historyLength
		 ifTrue: [commandsHistory removeLast].
! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 12/27/2008 23:16'!
removeAllOutput

	self cellsDo: [:cell | cell removeOutput]
! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 12/20/2008 00:03'!
removeComment

	| fullText  |

	fullText _ notebook getMyText.

	notebook updateText: (fullText copyFrom: 1 to: start -4), 
		(fullText copyFrom: start -1 to: fullText size).

	notebook refreshDisplay: notebook prompt.! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 12/23/2008 12:38'!
removeOutput

	^ self output: String cr
! !

!NotebookCell methodsFor: 'edition' stamp: 'spfa 12/19/2008 20:54'!
replaceFrom: anIndex to: bIndex with: aText

	| emorphs fullText |

	fullText _ notebook getMyText.
	emorphs _ fullText embeddedMorphsFrom: anIndex to: bIndex. 

	notebook updateText: (bIndex = fullText size ifTrue: 
			[(fullText copyFrom: 1 to: anIndex), aText]
		ifFalse: [(fullText copyFrom: 1 to: anIndex), aText,
					(fullText copyFrom: bIndex to: fullText size)]).

	emorphs do: [:m | m delete].

	notebook refreshDisplay: notebook prompt! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 12/27/2008 23:32'!
rewritedFromCells

	(Notebook new: self headerLabel
		contents: self contents) openInWorld
! !

!REPLTextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 5/26/2006 11:25'!
selectionAsStream
	"Answer a ReadStream on the text in the paragraph that is currently 
	selected."

	^PositionableStream
		on: paragraph string
		from: self startIndex
		to: self stopIndex - 1! !

!REPLMorph methodsFor: 'display stream protocol' stamp: 'spfa 6/23/2008 21:41'!
semaphore

	^ semaphore ifNil: [semaphore _ Semaphore forMutualExclusion]! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 12/22/2008 22:39'!
separator

	^ (Character value: 2) asText 
			addAttribute: (TextColor color: Color transparent) from: 1 to: 1! !

!REPLMorph methodsFor: 'contents' stamp: 'spfa 12/23/2008 15:03'!
setMyText: text

	| command  |

	(self hasProperty: #inCommand)
	ifTrue:
	[ | psize form |
		psize _ myContents size.
		(psize <= text size) ifTrue:
		[
			self updateText: 
				((text, String cr) 
					addAttributes: self class commandAttributes from: psize + 1 to: text size+1;
					addAttribute: self class displayFontAttribute from: psize + 1 to: text size+1).
			self refreshDisplay: ''.
			form _ text copyFrom: psize + 1 to: text size.
			self registerCommand: form asString.
			evaluator inputStream nextPutAll: form asString.
			evaluator inputStream skip: form size negated.
		].
		^ self 
	].

	(command _ self currentCommandFor: text) isEmpty 
	ifFalse: [ 
			self updateText: text, String cr.
			self refreshDisplay: ''.
	"		[self doCommand: command] fork."
			self doCommand: command
	]
	ifTrue: [self updateText: text ].

! !

!REPLMorph methodsFor: 'initialization' stamp: 'spfa 6/16/2008 13:43'!
setText: aText
	scrollBar setValue: 0.0.
	textMorph
		ifNil: [textMorph := REPLTextMorphForEditView new
						contents: aText wrappedTo: self innerBounds width-6.
				textMorph setEditView: self.
				scroller addMorph: textMorph]
		ifNotNil: [textMorph newContents: aText].
	self hasUnacceptedEdits: false.
	self setScrollDeltas.! !

!REPLPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'spfa 6/16/2008 13:43'!
setText: aText
	scrollBar setValue: 0.0.
	textMorph
		ifNil: [textMorph := REPLTextMorphForEditView new
						contents: aText wrappedTo: self innerBounds width-6.
				textMorph setEditView: self.
				scroller addMorph: textMorph]
		ifNotNil: [textMorph newContents: aText].
	self hasUnacceptedEdits: false.
	self setScrollDeltas.! !

!REPLPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'spfa 6/1/2006 09:55'!
spawn! !

!REPLTextMorphEditor methodsFor: 'as yet unclassified' stamp: 'spfa 6/1/2006 09:54'!
spawn

	! !

!NotebookCell methodsFor: 'accessing' stamp: 'spfa 12/23/2008 12:47'!
start

	^ start! !

!Notebook methodsFor: 'stepping' stamp: 'spfa 12/17/2008 15:54'!
step

	(self hasProperty: #refreshDisplay) ifTrue: [
		self removeProperty: #refreshDisplay.
		^ self refreshDisplay: self prompt].

	geometriesCache ifNil: [^ self].
	geometriesCache keysAndValuesDo: [:m :xt |
		m extent ~= xt ifTrue: [^ self refreshDisplay: self prompt]]! !

!REPLMorph methodsFor: 'stepping' stamp: 'spfa 6/17/2008 11:35'!
step

	self endEntry! !

!Notebook methodsFor: 'stepping' stamp: 'spfa 12/15/2008 15:16'!
stepTime

	^ 25! !

!REPLMorph methodsFor: 'stepping' stamp: 'spfa 6/17/2008 11:35'!
stepTime

	^ 200! !

!Notebook methodsFor: 'private-devel' stamp: 'spfa 12/28/2008 11:25'!
storeAsSelector: aSymbol in: aClass

	aClass compileNewSelectorNamed: aSymbol streamContents: [:str |
		str tab; nextPutAll: '^ Notebook new: ', self headerLabel storeString; cr.
		str tab; tab; nextPutAll: 'contents: #( '; cr.
		self stringContents do: [:cell |
			str tab; tab; tab.
			cell isString ifTrue: [str nextPutAll: cell storeString].
			cell isArray ifTrue: [str nextPutAll: cell printString allButFirst].
			str cr].
		str tab; tab; nextPutAll: ')'].

! !

!Notebook methodsFor: 'private-devel' stamp: 'spfa 12/28/2008 11:44'!
storeAsSelector: aSymbol in: aClass classifiedUnder: bSymbol

	self storeAsSelector: aSymbol in: aClass.
	aClass class organization classify: aSymbol under: bSymbol.

	self setProperty: #storage 
		toValue: (MessageSend receiver: aClass selector: aSymbol)
! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 12/27/2008 23:39'!
stringContents

	^ Array streamContents: [:str |
		self cellsDo: [:cell | 
			| comment |
			(comment _ cell comment)
				ifNil: [str nextPut: cell inputString]
				ifNotNil: [
					str nextPut: {
							comment contents asString.
							cell inputString
						}]]]
! !

!Notebook methodsFor: 'contents' stamp: 'spfa 12/19/2008 18:26'!
swap: aMorph

	self setProperty: #swap toValue: aMorph.
	aMorph color: Color orange! !

!REPLMorph methodsFor: 'display stream protocol' stamp: 'spfa 5/29/2008 12:36'!
update: aSymbol 

	aSymbol ifNil: [^self].

	aSymbol == #endEntry 
		ifTrue: 
			[self endEntry].

	aSymbol == #appendEntry 
		ifTrue: 
			[self appendEntry].
	aSymbol == #clearText 
		ifTrue: 
			[self clear].
	aSymbol == #force 
		ifTrue: 
			[self outputQueue].! !

!REPLMorph methodsFor: 'contents' stamp: 'spfa 6/25/2008 11:26'!
updateText: text

	| ttext |

	ttext _ text size > self characterLimit 
		ifTrue: [text copyFrom: text size - self characterLimit to: text size]
		ifFalse: [text].

	super setMyText: ttext.
! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 6/29/2008 14:47'!
wantsDroppedMorph: aMorph event: evt

	^ aMorph hasProperty: #replCommands
	
	! !

!REPLMorph methodsFor: 'initialization' stamp: 'spfa 6/18/2006 23:05'!
wantsFrameAdornments

	^ false! !

!Notebook methodsFor: 'stepping' stamp: 'spfa 12/15/2008 15:12'!
wantsSteps

	^ true! !

!REPLMorph methodsFor: 'stepping' stamp: 'spfa 6/17/2008 11:35'!
wantsSteps

	^ true! !

!Notebook class methodsFor: 'instance creation' stamp: 'spfa 12/23/2008 14:46'!
windowColor

	^ Color greenYellow darker! !

!Notebook methodsFor: 'buttons' stamp: 'spfa 1/5/2009 09:20'!
wrapForOutput: aMorph

	| m controls hbutt |

	m _ Morph new
			extent: 3@3;
			color: Color transparent;
			layoutInset: 3;
			cellInset: 3;
			wrapCentering: #center;
			hResizing: #shrinkWrap;
			vResizing: #shrinkWrap;
			listDirection: #leftToRight;
			layoutPolicy: TableLayout new.

	controls _ m veryDeepCopy cellInset: 1; listDirection: #topToBottom.

	m addMorph: controls.
	m addMorph: aMorph.

	hbutt _ self buttonMorph label: 'show';
								 target: m; actionSelector: #become:.
	hbutt arguments: {hbutt}.

	controls addMorph: (self buttonMorph label: 'hide';
								 target: m; actionSelector: #become:;
								 arguments: {hbutt}).

	controls addMorph: (self buttonMorph label: 'pick';
								 target: aMorph; actionSelector: #openInHand).

	controls addMorph: (self buttonMorph label: 'halo';
								 target: aMorph; actionSelector: #addHalo).

	^ m asAnchoredText
! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 6/18/2006 22:06'!
yellowButtonActivity

	(self getMenu: false) invokeModal! !

!REPLPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'spfa 6/18/2006 21:32'!
yellowButtonActivity

	(self getMenu: false) invokeModal! !

!REPLMorph methodsFor: 'command processing' stamp: 'spfa 6/18/2006 22:06'!
yellowButtonActivity: shiftKeyState

	(self getMenu: shiftKeyState) invokeModal! !

!REPLPluggableTextMorph methodsFor: 'as yet unclassified' stamp: 'spfa 6/18/2006 21:31'!
yellowButtonActivity: shiftKeyState

	(self getMenu: shiftKeyState) invokeModal! !
